import React from 'react';
import { Upload, Icon, message } from 'antd';
import './style.less';
import { uploaderProps } from '../../utils/upload';



class ImageUpload extends React.Component {

  state = {
    loading: false,
    previewVisible: false,
    previewImage: '',
    fileList: [],
  };

  componentDidUpdate() {  this.setState({ fileList: [{
    uid: '-1',
    name: 'image.png',
    status: 'done',
    url: this.props.value,
  }] })  }


  handleChange = ({ file, fileList }) => {
    const { status, response } = file
    this.setState({ fileList, loading: status === "uploading" })

    if (typeof this.props.onChange === 'function') {
      const image = status === 'done' ? response : undefined
      this.props.onChange(image);
    }
  };

  handlePreview = async file => {
    this.setState({
      previewImage: file.response,
      previewVisible: true,
    });
  };

  render() {
    const uploadButton = (
      <div>
        <Icon style={{ fontSize: '2em', color: '#aaa' }} type={this.state.loading ? "loading" : "plus"} />
      </div>
    );

    return (
      <Upload
        {...uploaderProps}
        listType="picture-card"
        className="avatar-uploader"
        onChange={this.handleChange}
        fileList={this.state.fileList}
        onPreview={this.handlePreview}
      >
        {this.state.fileList.length >= 1 ? null : uploadButton}  
      </Upload>
    );
  }
}

export default ImageUpload;
